$("html").append("<div id='receptionist-container'></div>");
$("#receptionist-container").append("<div id='receptionist-circle' class='receptionist-fetch receptionist-start'></div>");
$("#receptionist-container").append("<div class='hide' id='receptionist-content-wrapper'></div>");
$("#receptionist-content-wrapper").append("<div id='receptionist-widget-container'></div>");
$("#receptionist-widget-container").append("<div id='receptionist-widget-header'></div>");
$("#receptionist-widget-container").append("<div id='receptionist-widget-content'></div>");
$("#receptionist-widget-header").append("<span></span>");
$("#receptionist-widget-header").append("<div id='receptionist-close-widget-cross'></div>");

$(window).scroll(function() {
  if ($('#receptionist-content-wrapper:hover').length != 0) {
    console.log("dont scrolllll");
  } else {
    if (!$('#receptionist-form-container').length) {
      hideWidget()
    }
  }
});

function callSelectBox(thisObj) {
  if (window.innerHeight < 650 || window.innerWidth < 1000) {
    minimal_initial = true
  }
  if (thisObj == "onLoad") {
    var newAnswer = ["-1"]
    console.log(minimal_initial);
    console.log("callSelectBox minimal_initial", minimal_initial);
  }
  else if (thisObj.hasClass("receptionist-start")) {
    var newAnswer = ["-1"]
    minimal_initial = false
    resetWidget()
  } else {
    var newAnswer = ["single_option", parseInt(thisObj.attr("id"))]
    minimal_initial = false
  }
  console.log(newAnswer);
  $.ajax({
    type: "GET",
    statusCode: {500: function() {alert( "Jokin meni vikaan :(" );}},
    url: 'https://selectboxapp.herokuapp.com/fetch/',
    data: {
      'new_answer': newAnswer,
      'area': receptionist_area,

      'current_question_order': ["0"],
      'current_question_set': ["-1"],
      'prev_question_sets': [""],
      'last_questions_in_prev_sets': [""],
      'queued_sets': [""],
      'selected_answers': [""],
      'selected_must_have_features': [""],
      'selected_nice_to_have_features': [""],
      'selected_categories': [""],
      'selected_quantities': [""],
      'selected_ideals': [""],
    },
    success: function(data) {

      var openingURLs = 0
      console.log(data);

      if($.inArray(window.location.href, data["settings"]["opening_urls"]) !== -1 && window.innerWidth > 480) {
        var open_widget = true
      } else {
        var open_widget = false
      }

      console.log("open widget", open_widget);

      if (thisObj == "onLoad" && open_widget == false) {

        // Do not open

      } else {
        $("#receptionist-widget-content").css("opacity", 1)
        $("#receptionist-widget-content").html("")
        $("#receptionist-widget-content").append("<div id='receptionist-minilogo-container'><a target='_blank' style='line-height: 0px;' href='https://selectbox.io'><img src='https://selectboxapp.herokuapp.com/static/images/mini_recep_logo.svg' id='receptionist-widget-logo'></img></a></div>");

        if (!data['response']['question']) {

          // Show result
          $("#receptionist-widget-header > span").text(data['response']['result_list'][0]["fields"]["title"]);
          $("#receptionist-widget-content").prepend("<pre id='receptionist-result-content'>"+data['response']['result_list'][0]["fields"]["description"]+"</pre>");

          if (data['response']['result_list'][0]["fields"]["img_url"]) {
            $("#receptionist-result-content").prepend("<img src="+data['response']['result_list'][0]["fields"]["img_url"]+" id='receptionist-result-img'>");
          }

          $("#receptionist-minilogo-container").css("justify-content", "space-between");
          $("#receptionist-minilogo-container").prepend("<div id='receptionist-submit-buttons'></div>");
          $("#receptionist-submit-buttons").append("<button class='receptionist-fetch receptionist-start'>Mene alkuun</button>");

        } else {

          // Show question

          $("#receptionist-widget-header > span").text(data['response']['question'][0]["fields"]["title"]);
          $("#receptionist-widget-content").prepend("<div id='receptionist-list-content'></div>");
          $.each(data['response']['answer_list'], function( index, value ) {
            console.log(value);
            var ans_action_link = value["fields"]["open_this_page"]
            console.log(ans_action_link);
            var ans_action_form = value["fields"]["open_this_form"]
            console.log(ans_action_form);
            var ans_action_follow_up = value["fields"]["follow_up_question"]
            console.log(ans_action_follow_up);

            if (ans_action_link) {
              $("#receptionist-list-content").append("<div class='receptionist-list-item-wrapper'><a id='' class='receptionist-anchor-override' href="+ans_action_link+"><div id="+value["pk"]+" class='receptionist-list-item'>"+value["fields"]["title"]+"</div></a></div>");
            } else if (ans_action_form) {
              $("#receptionist-list-content").append("<div class='receptionist-list-item-wrapper'><div id="+ans_action_form+" class='selectbox-open-form receptionist-list-item'>"+value["fields"]["title"]+"</div></div>");
            } else {
              $("#receptionist-list-content").append("<div class='receptionist-list-item-wrapper'><div id="+value["pk"]+" class='receptionist-fetch receptionist-list-item'>"+value["fields"]["title"]+"</div></div>");
            }
          });

        }
        console.log("minimal_initial", minimal_initial);
        $("#receptionist-content-wrapper").css("width", "300px")
        if (minimal_initial && window.innerWidth > 480) {
          applyMinimal()
          minimal_initial = false
        }
        showWidget()
      }



    },
    failure: function(data) {alert('Got an error dude');}
  });
}

$(document).on('click', ".receptionist-fetch", function(e) {
  $("#receptionist-widget-content").css("opacity", 0)
  callSelectBox($(this))
});

$(document).on('click', ".selectbox-open-form", function(e) {



  $.ajax({
    type: "GET",
    statusCode: {500: function() {alert( "Jokin meni vikaan :(" );}},
    url: 'https://selectboxapp.herokuapp.com/fetch/',
    data: {
      'form_id': $(this).attr("id"),
      'area': receptionist_area,
    },
    success: function(data) {
      $("#receptionist-widget-content").css("opacity", 1)
      $("#receptionist-widget-content").html("")
      $("#receptionist-widget-content").append("<div id='receptionist-form-container' class=''></div>");
      $("#receptionist-form-container").append("<div id='receptionist-form-content'></div>");
      $("#receptionist-widget-header > span").text(data['form_obj'][0]["fields"]["title"]);
      $("#receptionist-widget-header").append("<div class='hide' id='form-id'></div>")
      $("#form-id").text(data['form_obj'][0]["pk"])
      $.each(data['form_fields'], function( index, value ) {
        title = this["fields"]["title"]
        desc = this["fields"]["description"]
        lines = this["fields"]["lines"]
        field_id = this["pk"]
        $("#receptionist-form-content").append("<p class='receptionist-form-title'>"+title+"</p><p class='receptionist-form-desc'>"+desc+"</p><textarea class='receptionist-form-textarea' rows='"+lines+"' id='"+field_id+"'></textarea>");
      });


      $("#receptionist-widget-content").append("<div id='receptionist-minilogo-container'><a target='_blank' style='line-height: 0px;' href='https://selectbox.io'><img src='https://selectboxapp.herokuapp.com/static/images/mini_recep_logo.svg' id='receptionist-widget-logo'></img></a></div>");

      $("#receptionist-minilogo-container").css("justify-content", "space-between");

      $("#receptionist-minilogo-container").prepend("<div id='receptionist-submit-buttons'></div>");

      $("#receptionist-submit-buttons").append("<button id='receptionist-submit-form'>Lähetä</button>");
      $("#receptionist-submit-buttons").append("<button class='receptionist-fetch receptionist-start' id='receptionist-close-form'>Peruuta</button>");

      $("#receptionist-content-wrapper").css("width", "500px");
      $("#receptionist-content-wrapper").css("max-width", "90vw");

      console.log(data);
    },
    failure: function(data) {alert('Got an error dude');}
  });
});

$(document).on('click', "#receptionist-submit-form", function(e) {
  var form_data = []
  $( ".receptionist-form-textarea" ).each(function( index ) {
    form_data.push($(this).attr("id") + "{{%%}}" + $(this).val())
  });

  $.ajax({
    type: "POST",
    statusCode: {500: function() {alert( "Jokin meni vikaan :(" );}},
    url: 'https://selectboxapp.herokuapp.com/receptionist/form/submit',
    data: {
      'form_id': $("#form-id").text(),
      'form_data': form_data,
      'area': receptionist_area,
    },
    success: function(data) {
      $("#receptionist-close-form").remove()
      $("#receptionist-submit-form").remove()
      $("#receptionist-submit-buttons").prepend("<button style='margin-bottom: 0px;' class='receptionist-fetch receptionist-start' id='receptionist-close-form'>Sulje lomake</button>");
      $("#receptionist-minilogo-container").prepend("<p style='color: dimgrey;margin-bottom: 2px;margin-top: 11px;font-size: 14px;' id='submit-form-success'>Viesti lähetetty onnistuneesti!</p>");


    },
    failure: function(data) {alert('Got an error dude');}
  });
});

function hideWidget() {
  $("#receptionist-content-wrapper").fadeOut(function() {
    escapeMinimal()
  });

}

function showWidget() {
  $("#receptionist-content-wrapper").fadeIn()
}

function resetWidget() {
}

function applyMinimal() {
  $("#receptionist-circle").removeClass("receptionist-fetch")
  $("#receptionist-widget-header").append("<span id='receptionist-heading-explainer'>Klikkaa tästä</span>")
  $("#receptionist-content-wrapper").addClass("receptionist-content-wrapper-minimal")
  $("#receptionist-widget-header").addClass("receptionist-widget-header-minimal")
  $("#receptionist-widget-content").addClass("receptionist-widget-content-minimal")
  $("#receptionist-close-widget-cross").hide()
}

function escapeMinimal() {
  $("#receptionist-circle").addClass("receptionist-fetch")
  $("#receptionist-heading-explainer").remove()
  $("#receptionist-content-wrapper").removeClass("receptionist-content-wrapper-minimal")
  $("#receptionist-widget-header").removeClass("receptionist-widget-header-minimal")
  $("#receptionist-widget-content").removeClass("receptionist-widget-content-minimal")
  $("#receptionist-close-widget-cross").show()
}

$(document).on('click', ".receptionist-content-wrapper-minimal", function(e) {
  escapeMinimal()
});

$(document).on('click', "#receptionist-circle", function(e) {
  if ($('.receptionist-content-wrapper-minimal').length) {
    escapeMinimal()
  }
});

$(document).on('click', "#receptionist-close-form", function(e) {

});

$(document).on('click', "#receptionist-close-widget-cross", function(e) {
  hideWidget()
});

$( document ).ready(function() {
  console.log( "ready!" );
  setTimeout(
  function()
  {
    callSelectBox("onLoad")
  }, 1000);

});
