var savedRemoved = []
var question_id = 0
var question_set_id = 0
var feature_question_relations = {}
var response = {}

// Init client state from memory if found
if (Cookies.get("currentQuestionOrder")) {
  var currentQuestionOrder = parseInt(Cookies.get("currentQuestionOrder"))
} else {
  var currentQuestionOrder = ["0"]
}

if (Cookies.get("currentQuestionSet")) {
  var currentQuestionSet = parseInt(Cookies.get("currentQuestionSet"))
} else {
  var currentQuestionSet = ["-1"]
}

if (Cookies.get("prevQuestionSets")) {
  var prevQuestionSets = Cookies.get("prevQuestionSets")
  prevQuestionSets = JSON.parse("[" + prevQuestionSets + "]")[0];
} else {
  var prevQuestionSets = [""]
}

if (Cookies.get("lastQuestionsInPrevSets")) {
  var lastQuestionsInPrevSets = Cookies.get("lastQuestionsInPrevSets")
  lastQuestionsInPrevSets = JSON.parse("[" + lastQuestionsInPrevSets + "]")[0];
} else {
  var lastQuestionsInPrevSets = [""]
}

if (Cookies.get("queuedSets")) {
  var queuedSets = Cookies.get("queuedSets")
  queuedSets = JSON.parse("[" + queuedSets + "]")[0];
} else {
  var queuedSets = [""]
}

if (Cookies.get("selectedAnswers")) {
  var selectedAnswers = Cookies.get("selectedAnswers")
  selectedAnswers = JSON.parse("[" + selectedAnswers + "]")[0];
} else {
  var selectedAnswers = [""]
}

if (Cookies.get("selectedMustHaveFeatures")) {
  var selectedMustHaveFeatures = Cookies.get("selectedMustHaveFeatures")
  selectedMustHaveFeatures = JSON.parse("[" + selectedMustHaveFeatures + "]")[0];
} else {
  var selectedMustHaveFeatures = [""]
}

if (Cookies.get("selectedNiceToHaveFeatures")) {
  var selectedNiceToHaveFeatures = Cookies.get("selectedNiceToHaveFeatures")
  selectedNiceToHaveFeatures = JSON.parse("[" + selectedNiceToHaveFeatures + "]")[0];
} else {
  var selectedNiceToHaveFeatures = [""]
}

if (Cookies.get("selectedCategories")) {
  var selectedCategories = Cookies.get("selectedCategories")
  selectedCategories = JSON.parse("[" + selectedCategories + "]")[0];
} else {
  var selectedCategories = [""]
}

if (Cookies.get("selectedQuantities")) {
  var selectedQuantities = Cookies.get("selectedQuantities")
  selectedQuantities = JSON.parse("[" + selectedQuantities + "]")[0];
} else {
  var selectedQuantities = [""]
}

if (Cookies.get("selectedIdeals")) {
  var selectedIdeals = Cookies.get("selectedIdeals")
  selectedIdeals = JSON.parse("[" + selectedIdeals + "]")[0];
} else {
  var selectedIdeals = [""]
}

// Log variable states
console.log("");
console.log("selectedAnswers", selectedAnswers);
console.log("selectedMustHaveFeatures", selectedMustHaveFeatures);
console.log("selectedNiceToHaveFeatures", selectedNiceToHaveFeatures);
console.log("selectedCategories", selectedCategories);
console.log("selectedQuantities", selectedQuantities);
console.log("selectedIdeals", selectedIdeals);
console.log("currentQuestionOrder", currentQuestionOrder);
console.log("currentQuestionSet", currentQuestionSet);
console.log("prevQuestionSets", prevQuestionSets);
console.log("lastQuestionsInPrevSets", lastQuestionsInPrevSets);
console.log("queuedSets", queuedSets);


//
// Create HTML
//

// Main Container
$("#app").append("<div class='selectbox-main-container'></div>");

// Welcome splash
$(".selectbox-main-container").append("<div class='selectbox-welcome-div selectbox-col-center-children'></div>");
$(".selectbox-welcome-div").append("<img scr='' class='selectbox-logo'></img>");
$(".selectbox-welcome-div").append("<h2 class='selectbox-welcome-heading'></h2>");
$(".selectbox-welcome-div").append("<p class='selectbox-welcome-subheading'></p>");
$(".selectbox-logo").attr("src", selectbox_logo_url);
$(".selectbox-welcome-heading").append(main_heading);
$(".selectbox-welcome-subheading").append(sub_heading);
$(".selectbox-welcome-div").append("<div class='selectbox-center-children selectbox-item-button selectbox-start selectbox-fetch'>" + start_button + "</div>");


// HIDDEN TEMPORARELY - Reapply when state variables have area_id on them
/*
if (Cookies.get("selectedAnswers")) {
  $(".selectbox-welcome-div").append("<div class='selectbox-center-children selectbox-item-button selectbox-fetch reget-results reget-from-start'>"+ "Katsele edellisiä tuloksia" +"</div>");
}
*/

// Sidemenu
$(".selectbox-main-container").append("<div style='display:none' class='selectbox-sidemenu-div'></div>");
$(".selectbox-sidemenu-div").append("<img scr='' class='selectbox-sidemenu-logo'></img>");
$(".selectbox-sidemenu-logo").attr("src", selectbox_logo_url);
$(".selectbox-sidemenu-div").append("<div class='selectbox-sidemenu-items'></div>");

// Content
$(".selectbox-main-container").append("<div style='/*display:none*/' class='selectbox-content'></div>");

// Question Heading
$(".selectbox-content").append("<h2 class='selectbox-question-heading'></h2>");

// Questions and answers
$(".selectbox-content").append("<div style='display:none' class='selectbox-qa-div selectbox-col-center-children'></div>");
$(".selectbox-qa-div").append("<div class='selectbox-answer-items'></div>");

// Slider div
$(".selectbox-content").append("<div style='display:none' class='selectbox-slider-container'></div>");
$(".selectbox-slider-container").append("<div style='' class='selectbox-slider-text left-slider-text'>fdsafdsa</div>");
$(".selectbox-slider-container").append("<div style='' class='selectbox-slider-div'></div>");
$(".selectbox-slider-container").append("<div style='' class='selectbox-slider-text right-slider-text'>fdsafdsfdsa</div>");
$(".selectbox-slider-div").append("<div id='slider'></div>");
var slider = document.getElementById('slider');


// Bottom navigation
$(".selectbox-content").append("<div style='' class='selectbox-bottom-navi'></div>");
$(".selectbox-bottom-navi").append("<div class='selectbox-back-navi-holder'></div>");
$(".selectbox-bottom-navi").append("<div style='display:none' class='selectbox-next-navi-holder selectbox-fetch'></div>");

// Next navi
$(".selectbox-next-navi-holder").append("<button class='selectbox-blue-border-button'>SEURAAVA KYSYMYS <span>&#9654;</span> </button>");

// Results
$(".selectbox-content").append("<div style='' class='selectbox-results-container'></div>");
$(".selectbox-results-container").append("<div style='display:none' class='selectbox-results-div'></div>");
$(".selectbox-results-div").append("<div style='' class='selectbox-result-items'></div>");
$(".selectbox-results-div").append("<div style='display:none' class='selectbox-metabox-div'></div>");

// Metabox - Contact
$(".selectbox-metabox-div").append("<div class='selectbox-metaboxcontact-div'></div>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-contact-subheading'>Sähköposti:</p>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-metaboxcontact-info'  id='selectbox-email'>" + selectbox_email + "</p>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-contact-subheading'>Puhelin:</p>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-metaboxcontact-info'  id='selectbox-phone'>" + selectbox_phone + "</p>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-contact-subheading'>Osoite:</p>");
$(".selectbox-metaboxcontact-div").append("<p class='selectbox-metaboxcontact-info'  id='selectbox-address'>" + selectbox_address + "</p>");

// Metabox Buttons
$(".selectbox-metabox-div").append("<div class='selectbox-metaboxbutton-div'></div>");
$(".selectbox-metaboxbutton-div").append("<button class='start-over selectbox-start selectbox-fetch selectbox-button selectbox-metaboxbutton selectbox-blue-border-button'>ALOITA ALUSTA</button>");
$(".selectbox-metaboxbutton-div").append("<button onClick='window.print();' class='selectbox-button selectbox-metaboxbutton selectbox-blue-border-button'>TULOSTA TÄMÄ NÄKYMÄ</button>");

// No results
$(".selectbox-content").append("<div style='display:none' class='selectbox-no-results-div selectbox-col-center-children'></div>");
$(".selectbox-no-results-div").append("<h2 class='selectbox-noresults-heading'>Vaatimillasi ominaisuuksilla ei löytynyt tuotteita. <br> <span style='color: #0375C2;font-size: 30px;'> Kokeile uudestaan poistamalla ruksi ominaisuuksista joita et välttämättä tarvitsekaan.</span></h2>");
$(".selectbox-no-results-div").append("<div class='noresults-select'></div>");
$(".selectbox-no-results-div").append("<div class='noresults-counter-div selectbox-col-center-children'></div>");
$(".noresults-counter-div").append("<p style='display:none' class='selectbox-noresult-counter'><span class='selectbox-noresult-counter-number'></span><span class='selectbox-noresult-counter-text'></span></p>");
$(".noresults-counter-div").append("<button style='display:none' class='selectbox-fetch reget-results selectbox-button selectbox-blue-border-button'>NÄYTÄ</button>");



/*
// Reset after 5 minutes
var idleTime = 0;
$(document).ready(function () {
    //Increment the idle time counter every minute.
    var idleInterval = setInterval(timerIncrement, 60000); // 1 minute

    //Zero the idle timer on mouse movement.
    $(this).mousemove(function (e) {
        idleTime = 0;
    });
    $(this).scroll(function (e) {
        idleTime = 0;
    });
    $(this).keypress(function (e) {
        idleTime = 0;
    });
});
function timerIncrement() {
    idleTime = idleTime + 1;
    if (idleTime > 5) { // minutes
        window.location.reload();
    }
}
*/




//
// Do these things when clicking the checkboxes which appear when no results found
//

$(document).on('change', '.no-result-checkbox', function () {

  // Determine if the feature should be removed from requirements
  var remove_this = false
  if ($(this).is(":checked")) {
    remove_this = false
  } else {
    remove_this = true
  }

  // Find which question is related to the affected feature and apply line-throught to the question
  // feature_question_relations variable shows what questions and features are related
  var feature_id = $(this).val()
  $.each(feature_question_relations, function (index, value) {
    feature_question_relations_id = value["feature_id"]
    if (feature_id == feature_question_relations_id) {
      $(".selectbox-sidemenu-item").each(function (index, thisquestion) {
        var question_id = parseInt($(this).attr("id"))
        if ($.inArray(question_id, value["related_questions"]) != -1) {
          if (remove_this) {
            $(thisquestion).addClass("line-through")
          } else {
            $(thisquestion).removeClass("line-through")
          }
        } else {}
      });
    }
  });

  // For future reference, this will save the removed features to a savedRemoved variable
  savedRemoved = []
  $(".selectbox-sidemenu-item").each(function (index, thisquestion) {
    if ($(this).hasClass("line-through")) {
      savedRemoved.push(1)
    } else {
      savedRemoved.push(0)
    }
  });
  Cookies.set("savedRemoved", savedRemoved)

  // Recreate selectedMustHaveFeatures and selectedNiceToHaveFeatures according to the new situation
  selectedMustHaveFeatures = []
  selectedNiceToHaveFeatures = []
  $(".no-result-checkbox").each(function (index) {
    if ($(this).is(":checked")) {
      selectedMustHaveFeatures.push($(this).val())
    } else {
      selectedNiceToHaveFeatures.push($(this).val())
    }
  });

  // Check how many products can be found with the new situation
  $.ajax({
    type: "GET",
    statusCode: {
      500: function () {
        alert("Jokin meni vikaan :(");
      }
    },
    url: 'https://selectboxapp.herokuapp.com/check_prod_amount/',
    data: {
      'selected_must_have_features': selectedMustHaveFeatures,
      'selected_nice_to_have_features': selectedNiceToHaveFeatures,
      'selected_categories': selectedCategories,
      'area': selectbox_area,
    },
    success: function (data) {
      console.log(data);
      $(".selectbox-noresult-counter").show();
      $(".selectbox-noresult-counter-number").text(data["amount"])
      if (data["amount"] == 1) {
        $(".selectbox-noresult-counter-text").text("Yksi tuote täyttää nämä ominaisuudet");
        $(".selectbox-noresult-counter-number").text("")
        $(".reget-results").show();
      } else if (data["amount"] > 1) {
        $(".selectbox-noresult-counter-text").text(" tuotetta täyttää nämä ominaisuudet");
        $(".reget-results").show();
      } else {
        $(".selectbox-noresult-counter-text").text("Ei löytynyt tuotteita. Kokeile poistaa lisää ominaisuuksia");
        $(".selectbox-noresult-counter-number").text("")
        $(".reget-results").hide();
      }
    },
    failure: function (data) {
      alert('Got an error dude');
    }
  });
});



//
// Handle clicking of multi-select items
//

$(document).on('click', ".selectbox-multi-item-button", function (e) {
  $(this).removeClass("selectbox-multi-item-button")
  $(this).addClass("selectbox-remove-selection")
  if ($('.selectbox-remove-selection').length >= 1) {
    $(".selectbox-next-navi-holder").show()
  } else {
    $(".selectbox-next-navi-holder").hide()
  }
});
$(document).on('click', ".selectbox-remove-selection", function (e) {
  $(this).addClass("selectbox-multi-item-button")
  $(this).removeClass("selectbox-remove-selection")
  if ($('.selectbox-remove-selection').length >= 1) {
    $(".selectbox-next-navi-holder").show()
  } else {
    $(".selectbox-next-navi-holder").hide()
  }
});



//
// Main function for inputting user selection to server and getting data back
//

$(document).on('click', ".selectbox-fetch", function (e) {
  $(".selectbox-slider-container").hide();
  $(".selectbox-next-navi-holder").hide();
  if ($(this).hasClass("selectbox-start")) {

    //
    // Do this when user starts questionnare from the beginning
    //

    // Hide/show elements
    $(".selectbox-results-heading").hide();
    $(".selectbox-sidemenu-items").html("");
    $(".selectbox-qa-div").show();
    $(".selectbox-result-items").html("");
    $(".selectbox-metabox-div").hide();
    $(".selectbox-slider-container").hide();

    // Init client state
    currentQuestionOrder = ["0"]
    currentQuestionSet = ["-1"]
    prevQuestionSets = [""]
    lastQuestionsInPrevSets = [""]
    queuedSets = [""]
    selectedAnswers = [""]
    selectedMustHaveFeatures = [""]
    selectedNiceToHaveFeatures = [""]
    selectedCategories = [""]
    selectedQuantities = [""]
    selectedIdeals = [""]

    // Scroll view to app div if top of app not visible
    var top_of_element = $("#app").offset().top;
    var top_of_screen = $(window).scrollTop();
    if (top_of_screen > top_of_element) {
      var $window = $(window),
        $element = $('#app'),
        elementTop = $element.offset().top,
        elementHeight = $element.height(),
        viewportHeight = $window.height(),
        scrollIt = elementTop - ((viewportHeight - elementHeight) / 2);
      $window.scrollTop(scrollIt);
    }

    // this variable @ -1 tells selectbox to start questionnare from beginning
    var newAnswer = ["-1"]

  } else if ($(this).hasClass("reget-results")) {

    //
    // Do this when app needs to get the results again using the previous selections
    //

    // -2 tells selectbox to only get the results again with prev state
    var newAnswer = ["-2"]

    // Hide/show elements
    $(".selectbox-no-results-div").hide();
    $(".selectbox-sidemenu-items").html("")
    $(".noresults-select").html("")
    $(".selectbox-slider-container").hide();

    // Get state from client memory
    var savedAnswers = Cookies.get("savedAnswers")
    savedAnswers = JSON.parse("[" + savedAnswers + "]")[0];
    var savedQuestions = Cookies.get("savedQuestions")
    savedQuestions = JSON.parse("[" + savedQuestions + "]")[0];
    var savedRemoved = Cookies.get("savedRemoved")
    savedRemoved = JSON.parse("[" + savedRemoved + "]")[0];
    var savedHiddenOrders = Cookies.get("savedHiddenOrders")
    savedHiddenOrders = JSON.parse("[" + savedHiddenOrders + "]")[0];
    var savedHiddenSets = Cookies.get("savedHiddenSets")
    savedHiddenSets = JSON.parse("[" + savedHiddenSets + "]")[0];

    // Apply line-through to the question-list at the left hand side of UI
    $.each(savedQuestions, function (index, value) {
      if (savedRemoved[index] == 0) {
        $(".selectbox-sidemenu-items").append("<div class='selectbox-sidemenu-item selectbox-go-back selectbox-fetch' style=''><div class='selectbox-sidemenu-item-questiontext'>" + value + "</div><div class='selectbox-sidemenu-item-answertext'>" + savedAnswers[index] + "</div><div style='display:none;' class='selectbox-sidemenu-item-questionorder_hidden'>" + savedHiddenOrders[index] + "</div><div style='display:none;' class='selectbox-sidemenu-item-questionset_hidden'>" + savedHiddenSets[index] + "</div></div>")
      } else {
        $(".selectbox-sidemenu-items").append("<div class='selectbox-sidemenu-item selectbox-go-back selectbox-fetch line-through'><div class='selectbox-sidemenu-item-questiontext'>" + value + "</div><div class='selectbox-sidemenu-item-answertext'>" + savedAnswers[index] + "</div><div style='display:none;' class='selectbox-sidemenu-item-questionorder_hidden'>" + savedHiddenOrders[index] + "</div><div style='display:none;' class='selectbox-sidemenu-item-questionset_hidden'>" + savedHiddenSets[index] + "</div></div>")
      }
    });

    // if ($(this).hasClass("reget-from-start")) {}
  } else if ($(this).hasClass("selectbox-go-back")) {

    //
    // Do these things when user navigated back to a previous question
    //

    // Hide/show elements
    $(".selectbox-no-results-div").hide();
    $(".selectbox-results-div").hide();
    $(".selectbox-metabox-div").hide();
    $(".selectbox-result-items").html("");
    $(".selectbox-results-heading").remove();
    $(".noresults-select").html("")
    $(".selectbox-slider-container").hide();

    // Remove line-throughts
    $(".line-through").each(function (index) {
      $(this).removeClass("line-through")
    });

    // Clear all navigation list items after this one
    $(this).nextAll().remove()


    //
    // Recreate state variables (all this complexity can be eliminated by changing the stated variables to use "history format")
    //

    var amount_of_steps_before = $(this).prevAll().length + 1;

    if (amount_of_steps_before == 0) {
      var amount_of_steps_before_minus = 0
    } else {
      amount_of_steps_before_minus = amount_of_steps_before - 1
    }

    currentQuestionOrder = currentQuestionOrder.slice(0, amount_of_steps_before)
    currentQuestionSet = currentQuestionSet.slice(0, amount_of_steps_before)
    prevQuestionSets = prevQuestionSets.slice(0, amount_of_steps_before)
    lastQuestionsInPrevSets = lastQuestionsInPrevSets.slice(0, amount_of_steps_before)
    queuedSets = queuedSets.slice(0, amount_of_steps_before)
    selectedAnswers = selectedAnswers.slice(0, amount_of_steps_before)
    selectedMustHaveFeatures = selectedMustHaveFeatures.slice(0, amount_of_steps_before)
    selectedNiceToHaveFeatures = selectedNiceToHaveFeatures.slice(0, amount_of_steps_before)
    selectedCategories = selectedCategories.slice(0, amount_of_steps_before)
    selectedQuantities = selectedQuantities.slice(0, amount_of_steps_before)
    selectedIdeals = selectedIdeals.slice(0, amount_of_steps_before)

    newAnswer = selectedAnswers[-1]
    if (!newAnswer) {
      newAnswer = ["-1"]
    }

    $(this).remove()
  } else {

    if (response["question"][0]["fields"]["multi_option"] == true) {

      //
      // Multiselection case
      //

      var newAnswer = ["multi_option"]
      $(".selectbox-remove-selection").each(function (index) {
        newAnswer.push(parseInt($(this).attr("id")))
      });

      console.log(newAnswer);

      $(".selectbox-sidemenu-item#" + question_id).append("<div class='selectbox-sidemenu-item-answertext'>" + "Monta valintaa" + "</div>");

    } else if (response["question"][0]["fields"]["single_quantity"] == true) {

      //
      // Slider - single_quantity
      //

      var newAnswer = ["single_quantity"]
      // push quantity id to answer
      newAnswer.push(response["question"][0]["fields"]["quantity_category"] + ";")
      // push value to answer
      newAnswer[1] += slider.noUiSlider.get()

      slider.noUiSlider.destroy()

    } else if (response["question"][0]["fields"]["range_quantity"] == true) {

      //
      // Slider - range_quantity
      //

      var newAnswer = ["range_quantity"]
      // push quantity id to answer
      newAnswer.push(response["question"][0]["fields"]["quantity_category"] + ";")
      // push value to answer
      var slider_answers = slider.noUiSlider.get()
      newAnswer[1] += slider_answers[0] + "," + slider_answers[1]
      slider.noUiSlider.destroy()

    } else if (response["question"][0]["fields"]["ideal_quantity"] == true) {

      //
      // Slider - ideal_quantity
      //

      var newAnswer = ["ideal_quantity"]
      // push quantity id to answer
      newAnswer.push(response["question"][0]["fields"]["quantity_category"] + ";")
      // push value to answer
      newAnswer[1] += slider.noUiSlider.get()

      slider.noUiSlider.destroy()

    } else {

      //
      // User selected an answer, normal case
      //



      $(".selectbox-next-navi-holder").hide();

      var newAnswer = ["single_option", parseInt($(this).attr("id"))]
      $(".selectbox-sidemenu-item#" + question_id).append("<div class='selectbox-sidemenu-item-answertext'>" + $(this).text() + "</div>");

    }
    $(".selectbox-sidemenu-item#" + question_id).addClass("selectbox-go-back");
    $(".selectbox-sidemenu-item#" + question_id).addClass("selectbox-fetch");
    $(".sidemenu-item-selected").removeClass("sidemenu-item-selected")
  }

  // Hide elements while loading
  $(".selectbox-welcome-div").hide();
  $(".selectbox-question-heading").text("");
  $(".selectbox-answer-items").html("");

  //
  // Input variables to server and handle output
  //

  $.ajax({
    type: "GET",
    statusCode: {
      500: function () {
        alert("Jokin meni vikaan :(");
      }
    },
    url: 'https://selectboxapp.herokuapp.com/fetch/',
    data: {
      'new_answer': newAnswer,
      'current_question_order': currentQuestionOrder,
      'current_question_set': currentQuestionSet,
      'prev_question_sets': prevQuestionSets,
      'last_questions_in_prev_sets': lastQuestionsInPrevSets,
      'queued_sets': queuedSets,
      'selected_answers': selectedAnswers,
      'selected_must_have_features': selectedMustHaveFeatures,
      'selected_nice_to_have_features': selectedNiceToHaveFeatures,
      'selected_categories': selectedCategories,
      'selected_quantities': selectedQuantities,
      'selected_ideals': selectedIdeals,
      'area': selectbox_area,
    },
    success: function (data) {
      console.log(data);
      response = data['response']
      // Show elements
      console.log("show side menu", selectbox_show_side_menu);
      if (selectbox_show_side_menu == "True") {
        $('.selectbox-sidemenu-div').show();
      } else {
        $('.selectbox-content').css("width", "100%");
      }

      $('.selectbox-qa-div').show();

      if (data.response.answer_list) {

        //
        // Show new question
        //

        console.log(data['response']);

        $(".selectbox-question-heading").show();

        // get new question info from response
        question_id = data['response']["question"][0]["pk"]
        question_set = data['state']["current_question_set"]
        question_order = data['response']["question"][0]["fields"]["order"]

        // Push new item to navigation menu
        $(".selectbox-sidemenu-items").append("<div id=" + question_id + " class='selectbox-sidemenu-item sidemenu-item-selected'></div>")
        $(".selectbox-sidemenu-item#" + question_id).append("<div class='selectbox-sidemenu-item-questiontext'>" + data['response']["question"][0]["fields"]["title"] + "</div>");
        $(".selectbox-sidemenu-item#" + question_id).append("<div style='display:none;' class='selectbox-sidemenu-item-questionset_hidden'>" + question_set + "</div>");
        $(".selectbox-sidemenu-item#" + question_id).append("<div style='display:none;' class='selectbox-sidemenu-item-questionorder_hidden'>" + question_order + "</div>");

        // Update heading text
        $(".selectbox-question-heading").text(data['response']["question"][0]["fields"]["title"])

        if (data['response']['answer_list'].length == 0) {

          //
          // The question is a slider
          //

          var min_range = data['response']["question"][0]["fields"]["min_range"]
          var max_range = data['response']["question"][0]["fields"]["max_range"]
          var min_text = data['response']["question"][0]["fields"]["min_text"]
          var max_text = data['response']["question"][0]["fields"]["max_text"]
          var unit = data['response']["question"][0]["fields"]["unit"]

          $(".selectbox-next-navi-holder").show()
          $(".selectbox-slider-container").show()
          $(".left-slider-text").text(min_text)
          $(".right-slider-text").text(max_text)

          if (data['response']["question"][0]["fields"]["single_quantity"]) {
            noUiSlider.create(slider, {
              start: [(max_range / 2)],
              tooltips: [true],
              step: 1,
              connect: true,
              range: {
                'min': min_range,
                'max': max_range
              },
              format: {
                from: function (value) {
                  return parseInt(value);
                },
                to: function (value) {
                  return parseInt(value);
                }
              }
            });
          } else if (data['response']["question"][0]["fields"]["range_quantity"]) {
            noUiSlider.create(slider, {
              start: [(max_range * (1 / 3)), (max_range * (2 / 3))],
              tooltips: [true, true],
              step: 1,
              connect: true,
              range: {
                'min': min_range,
                'max': max_range
              },
              format: {
                from: function (value) {
                  return parseInt(value);
                },
                to: function (value) {
                  return parseInt(value);
                }
              }
            });
          } else {
            noUiSlider.create(slider, {
              start: [(max_range / 2)],
              tooltips: [false],
              step: 1,
              connect: true,
              range: {
                'min': min_range,
                'max': max_range
              },
              format: {
                from: function (value) {
                  return parseInt(value);
                },
                to: function (value) {
                  return parseInt(value);
                }
              }
            });
          }
        }

        // Iterate over new answer_list
        $.each(data['response']['answer_list'], function (index, value) {
          if (value["fields"]["img_url"]) {
            // If answer has image
            var ans_title = value["fields"]["title"]
            var img_url = value["fields"]["img_url"]
            var ans_id = value["pk"]
            $(".selectbox-answer-items").append("<div id=" + ans_id + " class='selectbox-answer-with-image selectbox-fetch selectbox-vert-center-children'></div>");
            $("#" + ans_id).append("<div class='selectbox-answer-img-div selectbox-vert-center-children'></div>");
            $("#" + ans_id + "> .selectbox-answer-img-div").append("<img src=" + img_url + " class='selectbox-answer-img'>");
            $("#" + ans_id).append("<p class='selectbox-answer-img-p'>" + ans_title + "</p>");
          } else {

            // If answer does not have image
            var ans_title = value["fields"]["title"]
            var ans_id = value["pk"]

            console.log("response value");
            console.log(data['response']["question"][0]["fields"]);

            if (data['response']["question"][0]["fields"]["multi_option"] == true) {
              $(".selectbox-answer-items").append("<div id=" + ans_id + " class='selectbox-item-button selectbox-multi-item-button selectbox-vert-center-children'>" + ans_title + "</div>");
            } else {
              $(".selectbox-answer-items").append("<div id=" + ans_id + " class='selectbox-item-button selectbox-fetch selectbox-vert-center-children'>" + ans_title + "</div>");
            }
          }
        });

        // Update client state
        currentQuestionOrder = data["state"]["current_question_order"]
        currentQuestionSet = data["state"]["current_question_set"]
        prevQuestionSets = data["state"]["prev_question_sets"]
        lastQuestionsInPrevSets = data["state"]["last_questions_in_prev_sets"]
        queuedSets = data["state"]["queued_sets"]
        selectedAnswers = data["state"]["selected_answers"]
        selectedMustHaveFeatures = data["state"]["selected_must_have_features"]
        selectedNiceToHaveFeatures = data["state"]["selected_nice_to_have_features"]
        selectedCategories = data["state"]["selected_categories"]
        selectedQuantities = data["state"]["selected_quantities"]
        selectedIdeals = data["state"]["selected_ideals"]

      } else {

        //
        // Show results
        //



        // Recreate savedRemoved variable
        // savedRemoved variable stores all removed features for future reference (for applying line-troughts when redrawing navigation-list)
        savedRemoved = []
        $(".selectbox-sidemenu-item").each(function (index, thisquestion) {
          if ($(this).hasClass("line-through")) {
            savedRemoved.push(1)
          } else {
            savedRemoved.push(0)
          }
        });
        Cookies.set("savedRemoved", savedRemoved)

        // This variable shows what questions and features are related
        feature_question_relations = data['response']["feature_question_relations"]

        // Update client state
        currentQuestionOrder = data["state"]["current_question_order"]
        currentQuestionSet = data["state"]["current_question_set"]
        prevQuestionSets = data["state"]["prev_question_sets"]
        lastQuestionsInPrevSets = data["state"]["last_questions_in_prev_sets"]
        queuedSets = data["state"]["queued_sets"]
        selectedAnswers = data["state"]["selected_answers"]
        selectedMustHaveFeatures = data["state"]["selected_must_have_features"]
        selectedNiceToHaveFeatures = data["state"]["selected_nice_to_have_features"]
        selectedCategories = data["state"]["selected_categories"]
        selectedQuantities = data["state"]["selected_quantities"]
        selectedIdeals = data["state"]["selected_ideals"]

        // Show and hide elements
        $(".selectbox-qa-div").hide();
        $(".selectbox-slider-container").hide();
        $(".selectbox-next-navi-holder").hide();
        $(".selectbox-question-heading").hide();

        if (data['response']["result_list"].length > 0) {

          //
          // Do these things if one or more results are found
          //

          // Show elements
          $(".selectbox-results-div").show();
          $(".selectbox-metabox-div").show();
          console.log("cont-info", selectbox_show_contant_info);
          if (selectbox_show_contant_info == "False") {
            $(".selectbox-metaboxcontact-div").hide();
          }

          // Show correct heading
          $(".selectbox-results-div").prepend("<h2 class='selectbox-results-heading'></h2>");
          if (data['response']["result_list"].length > 1) {
            $(".selectbox-results-heading").text(many_results)
          } else if (data['response']["result_list"].length = 1) {
            $(".selectbox-results-heading").text(one_result)
          } else {
            $(".selectbox-results-heading").text(no_results)
          }

          // Iterate over results
          $.each(data['response']["result_list"], function (index, value) {
            var title = value["fields"]["title"]
            var img = value["fields"]["img_url"]
            var desc = value["fields"]["description"]
            var link = value["fields"]["link"]
            var onlyInfo = value["fields"]["only_infotext"]
            
            // Create html
            
            if (!onlyInfo) {
              $(".selectbox-result-items").append("<div class='selectbox-result-item'id=" + value["pk"] + "><div class=''><div class='selectbox-result-img-div selectbox-vert-center-children'><img src=" + img + "></div><div class='selectbox-result-box'><div class='selectbox-result-heading'>" + title + "</div><p>" + desc + "</p><div class='selectbox-allfeatures-area'><div class='selectbox-musthavefeatures-area'><h4>Sisältää kaikki vaaditut ominaisuudet:</h4></div><div class='selectbox-nicetohavefeatures-area'><h4>Sisältää nämä toivotut ominaisuudet:</h4></div></div><a class='cta-link' target='_blank' href=" + link + "><button class='selectbox-button selectbox-blue-button selectbox-cta'>" + cta + "</button></a></div>");
              if (selectbox_show_cta == "False") {
                $(".cta-link").hide()
              }
            }
            if (onlyInfo) {
              $(".selectbox-result-items").prepend("<div class='selectbox-result-item'id=" + value["pk"] + "><p class='infotext'>" + desc + "</p></div>");
            } 

          });


          //
          // List nicetohave and musthave features on result-items
          //

          // List all the must have features on all results-items, if none, hide div
          if (data['response']["selected_must_have_objs"].length > 0) {
            $(".selectbox-result-item").each(function (index, value1) {
              $.each(data['response']["selected_must_have_objs"], function (index2, value2) {
                $(value1).find(".selectbox-musthavefeatures-area").append("<p class='small-feature'>" + value2["fields"]["title"] + "</p>")
              });
            });
          } else {
            $(".selectbox-musthavefeatures-area").hide();
          }

          // List all of the nice to have features which any result-item satisfies
          if (data['response']["satisfied_features"]) {
            $.each(data['response']["satisfied_features"], function (index, value) {
              if ($("selectbox-result-item#" + value['id'])) {
                $.each(value["features"], function (index, value2) {
                  $(".selectbox-result-item#" + value['id']).find(".selectbox-nicetohavefeatures-area").append("<p class='small-feature'>" + value2 + "</p>")
                });
              }
            });
          }

          // if no nice to have features, hide div
          $(".selectbox-result-item").each(function (index, value1) {
            if ($(value1).find(".selectbox-nicetohavefeatures-area").find("p").length == 0) {
              $(value1).find(".selectbox-nicetohavefeatures-area").hide()
            }
          });

        } else {

          //
          // No results are found - Ask to for looser query
          //

          // Show/hide elements
          $(".selectbox-no-results-div").show();
          $(".selectbox-noresult-counter").hide();
          $(".reget-results").hide();

          // Draw checkboxes
          $.each(data['response']["selected_must_have_objs"], function (index, value) {
            $(".noresults-select").append("<input class='no-result-checkbox' input type='checkbox' checked name='' value=" + value["pk"] + "> " + value["fields"]["title"] + " <br>");
          });

        }

        // Save state
        Cookies.set("currentQuestionOrder", currentQuestionOrder)
        Cookies.set("currentQuestionSet", currentQuestionSet)
        Cookies.set("prevQuestionSets", prevQuestionSets)
        Cookies.set("lastQuestionsInPrevSets", lastQuestionsInPrevSets)
        Cookies.set("queuedSets", queuedSets)
        Cookies.set("selectedAnswers", selectedAnswers)
        Cookies.set("selectedMustHaveFeatures", selectedMustHaveFeatures)
        Cookies.set("selectedNiceToHaveFeatures", selectedNiceToHaveFeatures)
        Cookies.set("selectedCategories", selectedCategories)
        Cookies.set("selectedQuantities", selectedQuantities)
        Cookies.set("selectedIdeals", selectedIdeals)

        // Save navigationmenu state variables
        var savedQuestions = []
        var savedAnswers = []
        var savedHiddenOrders = []
        var savedHiddenSets = []
        $(".selectbox-sidemenu-item").each(function (index) {
          savedQuestions.push($(this).find(".selectbox-sidemenu-item-questiontext").text())
          savedAnswers.push($(this).find(".selectbox-sidemenu-item-answertext").text())
          savedHiddenOrders.push($(this).find(".selectbox-sidemenu-item-questionorder_hidden").text())
          savedHiddenSets.push($(this).find(".selectbox-sidemenu-item-questionset_hidden").text())
        });
        Cookies.set("savedQuestions", savedQuestions)
        Cookies.set("savedAnswers", savedAnswers)
        Cookies.set("savedHiddenOrders", savedHiddenOrders)
        Cookies.set("savedHiddenSets", savedHiddenSets)

      }

      // Log variable states
      console.log("");
      console.log("selectedAnswers", selectedAnswers);
      console.log("selectedMustHaveFeatures", selectedMustHaveFeatures);
      console.log("selectedNiceToHaveFeatures", selectedNiceToHaveFeatures);
      console.log("selectedCategories", selectedCategories);
      console.log("selectedQuantities", selectedQuantities);
      console.log("selectedIdeals", selectedIdeals);
      console.log("currentQuestionOrder", currentQuestionOrder);
      console.log("currentQuestionSet", currentQuestionSet);
      console.log("prevQuestionSets", prevQuestionSets);
      console.log("lastQuestionsInPrevSets", lastQuestionsInPrevSets);
      console.log("queuedSets", queuedSets);
    },
    failure: function (data) {
      alert('Got an error dude');
    }
  });
});